diff -ur a/virtio_video/virtio_video_cam.c b/virtio_video/virtio_video_cam.c
--- a/virtio_video/virtio_video_cam.c
+++ b/virtio_video/virtio_video_cam.c
@@ -296,6 +296,35 @@ static int virtio_video_cam_s_selection(struct file *file, void *fh,
 	return ret;
 }
 
+static int virtio_video_cam_enum_input(struct file *file, void *fh,
+					struct v4l2_input *input)
+{
+	struct virtio_video_stream *stream = file2stream(file);
+	uint32_t index = input->index;
+
+	if (index != 0)
+		return -EINVAL;
+
+	memset(input, 0, sizeof(*input));
+	input->index = index;
+	snprintf(input->name, sizeof(input->name), "virtio_video_cam");
+	input->type = V4L2_INPUT_TYPE_CAMERA;
+	return 0;
+}
+
+static int virtio_video_cam_s_input(struct file *file, void *fh, unsigned int input)
+{
+	if (input != 0)
+		return -EINVAL;
+	return 0;
+}
+
+static int virtio_video_cam_g_input(struct file *file, void *fh, unsigned int *input)
+{
+	*input = 0;
+	return 0;
+}
+
 static const struct v4l2_ioctl_ops virtio_video_cam_ioctl_ops = {
 	.vidioc_querycap		= virtio_video_querycap,
 
@@ -330,6 +359,10 @@ static const struct v4l2_ioctl_ops virtio_video_cam_ioctl_ops = {
 
 	.vidioc_subscribe_event   = virtio_video_subscribe_event,
 	.vidioc_unsubscribe_event = v4l2_event_unsubscribe,
+
+	.vidioc_enum_input = virtio_video_cam_enum_input,
+	.vidioc_s_input = virtio_video_cam_s_input,
+	.vidioc_g_input = virtio_video_cam_g_input,
 };
 
 void *virtio_video_cam_get_fmt_list(struct virtio_video_device *vvd)
